/*******************************************************************************
 *  Copyright 2017 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *  
 *    http://www.apache.org/licenses/LICENSE-2.0
 *  
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.hl7282.baselibs;

import cdac.medinfo.sdk.hl7282.baselibs.segmentfactory.DataElementFactory;
import cdac.medinfo.sdk.hl7282.commoninterface.IDataType;
import cdac.medinfo.sdk.hl7282.commoninterface.ISingleCollection;
import cdac.medinfo.sdk.hl7282.exceptions.InvalidComponentTypeException;
import cdac.medinfo.sdk.hl7282.exceptions.InvalidDataTypeException;
import cdac.medinfo.sdk.hl7282.exceptions.InvalidValueException;
import cdac.medinfo.sdk.hl7282.exceptions.MissingValueException;
import cdac.medinfo.sdk.hl7282.utils.EnumDataType;
import cdac.medinfo.sdk.hl7282.utils.IDataTypeMap;

/**
 * HD - Hierarchic Designator<p>
 * This data type identifies an (administrative or system or application or 
 * other) entity that has responsibility for managing or assigning a 
 * defined set of instance identifiers (such as placer or filler number,
 *  patient identifiers, provider identifiers, etc.)
 * <p>Represents an HL7 HD data type. 
 * This data type has the following attributes:</p><p>
 *  1. Namespace ID (IS)<b>Optional</b><br>
 *  2. Universal ID (ST)<b>Conditional</b><br>
 *  3. Universal ID Type (ID)<b>Conditional</b><br><p>
 * This class provides accessors & mutators for the elements mentioned above.
 * This class override the equal method, to check whether some other object is "equal to" this one.
 * 
 * <p>User can also create Data Type through {@link DataElementFactory} 
 */
public class HD extends CompositeDataType    
{
	

	/**
	 * Default constructor for HD.
	 */
	public HD()
	{
		super(EnumDataType.HL7_DT_HD);
		 
	}
	/**
	 * Constructor for HD class which takes four arguments and 
	 * sets the value in the respective member variable.
	 * @param iMinLength The Minimum length the DataType can have.
	 * @param iMaxLength The Maximum length the DataType can have.
	 * @param iCLength The Conformance length the DataType can have.
	 * @param iComponentType The Type of the component i.e Component or a subcomponent.
	 * @throws InvalidComponentTypeException - if Component Type is not specified or valid. 
	 */
	public HD(int iMinLength, int iMaxLength, String strCLength,int iComponentType) throws InvalidComponentTypeException
	{
		this(iMinLength, iMaxLength,  strCLength,0,iComponentType);
		if(!isValidComponentType())
		{
			throw new InvalidComponentTypeException(this.getClass().getSimpleName());
		}
	}
	/**
	 * Constructor for HD class which takes five arguments and 
	 * sets the value in the respective member variable.
	 * @param iMinLength The Minimum length the DataType can have.
	 * @param iMaxLength The Maximum length the DataType can have.
	 * @param iCLength The Conformance length the DataType can have.
	 * @param iComponentType The Type of the component i.e Component or a subcomponent.
	 * @throws InvalidComponentTypeException - if Component Type is not specified or valid. 
	 */
	public HD(int iMinLength, int iMaxLength, String strCLength,int iTableNo,int iComponentType)
	{
		super(EnumDataType.HL7_DT_HD);
		this.iMinLength = iMinLength;
		this.iMaxLength = iMaxLength;
		this.iConformanceLength = strCLength;
		this.iTableNo = iTableNo;
		this.iComponentType = iComponentType;
		if(!isValidComponentType())
		{
			throw new InvalidComponentTypeException(this.getClass().getSimpleName());
		}
	}
	/**
	 * Constructor for HD class which takes four arguments and 
	 * sets the value in the respective member variable.
	 * @param objIDataTypeMap object of Data Type Map.
	 * @param iComponentType The Type of the component i.e Component or a subcomponent.
	 * @throws InvalidComponentTypeException - if Component Type is not specified or valid. 
	 */
	public HD(int iComponentType,IDataTypeMap objIDataTypeMap)
	{
		super(EnumDataType.HL7_DT_HD);
		this.objIDataTypeMap = objIDataTypeMap;
		this.iComponentType = iComponentType;

		if(!isValidComponentType())
		{
			throw new InvalidComponentTypeException(this.getClass().getSimpleName());
		}
	}
	/**
	 * Constructor for TS class which takes five arguments and 
	 * sets the value in the respective member variable.
	 * @param objIDataTypeMap object of Data Type Map.
	 * @param iComponentType The Type of the component i.e Component or a subcomponent.
	 * @param iMinLength The Minimum length the DataType can have.
	 * @param iMaxLength The Maximum length the DataType can have.
	 * @param iCLength The Conformance length the DataType can have.
	 * @throws InvalidComponentTypeException - if Component Type is not specified or valid. 
	 */
	public HD(int iComponentType,int iMinLength, int iMaxLength, String strCLength,IDataTypeMap objIDataTypeMap)
	{
		super(EnumDataType.HL7_DT_HD);
		this.objIDataTypeMap = objIDataTypeMap;
		this.iComponentType = iComponentType;
		this.iMinLength = iMinLength;
		this.iMaxLength = iMaxLength;
		this.iConformanceLength = strCLength;

		if(!isValidComponentType())
		{
			throw new InvalidComponentTypeException(this.getClass().getSimpleName());
		}
	}
	/**
	 * Constructor for HD class which takes six arguments and 
	 * sets the value in the respective member variable.
	 * @param objIDataTypeMap object of Data Type Map.
	 * @param iComponentType The Type of the component i.e Component or a subcomponent.
	 * @param iMinLength The Minimum length the DataType can have.
	 * @param iMaxLength The Maximum length the DataType can have.
	 * @param iCLength The Conformance length the DataType can have.
	 * @param iTableNo The Table number to which the value for the component is specified. 
	 * @throws InvalidComponentTypeException - if Component Type is not specified or valid. 
	 */
	public HD(int iComponentType,int iMinLength, int iMaxLength, String strCLength,int ITableNo,IDataTypeMap objIDataTypeMap)
	{
		super(EnumDataType.HL7_DT_HD);
		this.objIDataTypeMap = objIDataTypeMap;
		this.iComponentType = iComponentType;
		this.iTableNo = ITableNo;
		this.iMinLength = iMinLength;
		this.iMaxLength = iMaxLength;
		this.iConformanceLength = strCLength;

		if(!isValidComponentType())
		{
			throw new InvalidComponentTypeException(this.getClass().getSimpleName());
		}
	}	
	/**
	 * Sets the NamespaceId.
	 * @param strNamespaceId Specifies Specifies  the HL7 identifier for the user-defined table of values for this component.[Refer Table No.300]
	 */
	public void setNamespaceId(String strNamespaceId)
	{
		if(strNamespaceId!=null)
			setComponentType(1, strNamespaceId);
		else
			setNamespaceId((IS)null);
	}

	/**
	 * Sets the NamespaceId.
	 * @param objIS Specifies Specifies  the HL7 identifier for the user-defined table of values for this component.[Refer Table No.300]
	 */
	public void setNamespaceId(IS objIS)
	{
		setComponentType(1,objIS);
	}
	/**
	 * Sets the UniversalId.
	 * @param strUniversalId Specifies a string formatted according to the scheme defined by the component, <universal ID type> (UID type). 
	 */
	public void setUniversalId(String strUniversalId)
	{
		if(strUniversalId!=null)
			setComponentType(2, strUniversalId);
		else
			setUniversalId((ST)null);
	}
	/**
	 * Sets the UniversalId.
	 * @param objST Specifies a string formatted according to the scheme defined by the component, <universal ID type> (UID type). 
	 */
	public void setUniversalId(ST objST)
	{
		setComponentType(2,objST);
	}
	/**
	 * Sets the UniversalIdType.
	 * @param strUniversalIdType Governs the voiderpretation of the strUniversalId. 
	 * @return void - function status [success/failure].
	 */
	public void setUniversalIdType(String strUniversalIdType)
	{
		if(strUniversalIdType!=null)
			setComponentType(3, strUniversalIdType);
		else
			setUniversalIdType((ID)null);
	}
	/**
	 * Sets the UniversalIdType.
	 * @param objID Governs the voiderpretation of the strUniversalId. 
	 */
	public void setUniversalIdType(ID objID) throws InvalidDataTypeException
	{
		try
		{
			setComponentType(3, objID);
		}
		catch(InvalidDataTypeException ex)
		{
			throw new InvalidDataTypeException(this.getClass().getSimpleName(),ex);
		}
	}
	/**
	 * Returns Namespace ID
	 * @return IS - data type.
	 */
	public IS getNamespaceID()
	{
		ISingleCollection<IDataType> objDataCollection =getComponentType(1);
		if(objDataCollection != null && objDataCollection.size() != 0) 
			return (IS)objDataCollection.elementAt(0);
		else
			return null;
	}

	/**
	 * Returns Universal ID
	 * @return ST - data type.
	 */
	public ST getUniversalID()
	{
		ISingleCollection<IDataType> objDataCollection =getComponentType(2);
		if(objDataCollection != null && objDataCollection.size() != 0) 
			return (ST)objDataCollection.elementAt(0);
		else
			return null;
	}

	/**
	 * Returns Universal ID Type
	 * @return ID - data type.
	 */
	public ID getUniversalIDType()
	{
		ISingleCollection<IDataType> objDataCollection =getComponentType(3);
		if(objDataCollection != null && objDataCollection.size() != 0) 
			return (ID)objDataCollection.elementAt(0);
		else
			return null;
	}

	/**
	 * The Method validates the Input value,and if validated properly then returns true.
	 * Here the validetion is based on the compulsory fields for the Datatype. 
	 * @return boolean - true or false.
	 * @throws InvalidDataTypeException - if Invalid values is entered or Mandatory field is missing.
	 */
	public boolean validate() throws InvalidDataTypeException
	{
		super.validate();
		/*If the frist component is present the The remaining two are optional.
		 * If second is present then third is required and vice a versa.
		 * If all three are present then return true.
		 */
		if(getComponentType(1)!=null)
		{
			if(getComponentType(2)!=null &&getComponentType(3)!=null)
				return true;
			if(getComponentType(2)==null &&getComponentType(3)==null)
				return true;
			else 
			{
				String strMessage = "'UniversalID','UniversalID Type' both should be present or both should not be present.";
				throw new InvalidValueException(strMessage);
			}
		}
		else if(getComponentType(2)!=null &&getComponentType(3)!=null)
			return true;
		else
		{
			throw new MissingValueException(this.getClass().getSimpleName() + "");
		}
	}

	/**
	 * This method checks the equality of Object.
	 * @param objObject object of Object class.
	 * @return boolean - shows success or failure of the comparison.
	 */
	public boolean equals(Object objObject)
	{
		if((objObject == null ) || (!(objObject instanceof HD)))
			return false;

		if(this.getNamespaceID() == null)
		{
			if(((HD)objObject).getNamespaceID() != null)
				return false;
		}
		else if(false == (this.getNamespaceID().equals(((HD)objObject).getNamespaceID())))
			return false;

		if(this.getUniversalID() == null)
		{
			if(((HD)objObject).getUniversalID() != null)
				return false;
		}
		else if(false == (this.getUniversalID().equals(((HD)objObject).getUniversalID())))
			return false;

		if(this.getUniversalIDType() == null)
		{
			if(((HD)objObject).getUniversalIDType() != null)
				return false;
		}
		else if(false == (this.getUniversalIDType().equals(((HD)objObject).getUniversalIDType())))
			return false;

		return true;
	}
}
